local horizontalflingspeed = 54
local verticalflingspeed = 11
local floattime = TICRATE+TICRATE/3
local IDLETIME = TICRATE*6
local ELF_SPARKCOUNT = 0
freeslot("MT_ELFILIN_PORTAL",
"MT_ELFILIN_STAR",
"MT_ELFILIN_SLOPEHELPER",
"MT_ELFILIN_SPEAR",
"MT_ELFILIN_SPEAR_HITBOX",
"MT_ELFILISBALL",
"MT_ELFILIN_FOLLOWMOBJ",
"MT_JUMPBOOSTARROW",
"MT_ELFILIN_SPARKLE",
"MT_ELFILIN_PORTAL_GHOST",
"S_ELFILIN_SPARKLE",
"MT_ELFILIN_EYES",
"MT_ELFILIN_CHAOSSPEAR_ORIGIN",
"MT_ELFILIN_CHAOSSPEAR",
"MT_ELFILIN_EMERALD",
"MT_ELFILIN_SPARKLEBALL",
"S_JUMPBOOSTARROW",
"S_ELFILIN_STAR",
"S_ELFILIN_SPEAR",
"S_ELFILIN_CHAOSSPEAR",
"S_ELFILIN_PORTAL1",
"S_ELFILIN_PORTAL2",
"S_ELFILIN_PORTAL3",
"S_ELFILIN_PORTALBACK1",
"S_ELFILIN_PORTALBACK2",
"S_ELFILISBALL",
"S_PLAY_ELFILIN_TWIRL",
"S_PLAY_ELFILIN_WALK",
"S_PLAY_ELFILIN_RUN",
"S_PLAY_ELFILIN_STAND",
"S_PLAY_ELFILIN_WAIT1",
"S_PLAY_ELFILIN_WAIT2",
"S_PLAY_ELFILIN_WAIT3",
"S_PLAY_ELFILIN_ATTACK",
"S_PLAY_ELFILIN_RIDE",
"S_PLAY_ELFEYE",
"S_PLAY_ELFTRNS_1",
"S_PLAY_ELFTRNS_2",
"S_PLAY_ELFTRNS_3",
"S_PLAY_ELFTRNS_4",
"S_PLAY_ELFTRNS_5",
"S_PLAY_ELFTRNS_6",
"S_PLAY_ELFTRNS_7",
"S_PLAY_ELFTRNS_8",
"S_PLAY_ELFSTMP_1",
"S_PLAY_ELFSTMP_2",
"S_PLAY_ELFSTMP_3",
"S_PLAY_ELFSTMP_4",
"S_PLAY_ELFSTMP_5",
"S_PLAY_ELFSTMP_6",
"S_PLAY_ELFSTMP_7",
"S_PLAY_ELFSTMP_6_ALT",
"S_PLAY_ELFSTMP_7_ALT",
"S_PLAY_ELFSTMP_8",
"S_PLAY_ELFSTMP_9",
"S_PLAY_ELFSTMP_10",
"S_PLAY_ELFSTMP_11",
"S_PLAY_ELFSTMP_12",
"S_PLAY_ELFSTMP_END",
"SFX_ELFBND",
"SFX_ELF_1",
"SFX_ELF_2",
"SFX_ELF_3",
"SFX_ELF_4",
"SFX_ELF_5",
"SFX_ELF_6",
"SFX_ELF_7",
"SFX_CECIR",
"SFX_ESOUL",
"SFX_ESOUL2",
"SPR_ELSR",
"SPR_ELSP",
"SPR_CHSP",
"SPR_JMAR",
"SPR_ESPK",
"SPR_EPT1",
"SPR_EPT2",
"SPR_EPT3",
"SPR_EPB1",
"SPR_EPB2",
"SPR_EBAL",
"SFX_ELSLP1",
"SFX_ELSLP2",
"SFX_ELSP1",
"SFX_ELSP2",
"SFX_ELSP3",
"SKINCOLOR_PEACOCK",
"SKINCOLOR_SUPERSOUL1",
"SKINCOLOR_SUPERSOUL2",
"SKINCOLOR_SUPERSOUL3",
"SKINCOLOR_SUPERSOUL4",
"SKINCOLOR_SUPERSOUL5",
"SKINCOLOR_SUPERCRIMSON1",
"SKINCOLOR_SUPERCRIMSON2",
"SKINCOLOR_SUPERCRIMSON3",
"SKINCOLOR_SUPERCRIMSON4",
"SKINCOLOR_SUPERCRIMSON5"
)
sfxinfo[sfx_elsp3] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND
}
mobjinfo[MT_ELFILIN_SPARKLE] = {
	doomednum = -1,
	spawnstate = S_ELFILIN_SPARKLE,
	flags = MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ELFILIN_EYES] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	dispoffset = 3
}
mobjinfo[MT_ELFILISBALL] = {
	doomednum = -1,
	spawnstate = S_ELFILISBALL,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	dispoffset = 9
}
states[S_ELFILISBALL] = {
	sprite = SPR_EBAL,
	frame = FF_FULLBRIGHT,
	tics = -1,
	next = S_NULL
}
local v1 = 5
states[S_ELFILIN_SPARKLE] = {
	sprite = SPR_ESPK,
	frame = FF_ANIMATE|FF_FULLBRIGHT|TR_TRANS20,
	var1 = 3,
	var2 = v1,
	tics = v1*3,
	next = S_NULL
}
if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
if not P_SetOrigin then
    rawset(_G, "P_SetOrigin", P_TeleportMove)
end
if not P_MoveOrigin then
    rawset(_G, "P_MoveOrigin", P_TeleportMove)
end
if not SCRnofollowmobjcoloring
    rawset(_G, "SCRnofollowmobjcoloring", {})
end
local ElfEyes = {}
SCRnofollowmobjcoloring[MT_ELFILIN_FOLLOWMOBJ] = 1
kirbyabilitytable["elfilin"] = 16    // Makes the skin "exampleskin" give ice
skincolors[SKINCOLOR_PEACOCK] = {
    name = "Peacock",
    ramp = {0,120,121,122,122,123,123,124,124,125,125,126,126,127,138,139
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = true
}
skincolors[SKINCOLOR_SUPERSOUL1] = {
    name = "SUPER SOUL 1",
    ramp = {0,0,0,1,1,1,1,2,2,2,2,4,9,16,19,23
},
    invcolor = SKINCOLOR_SUPERCRIMSON5,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERSOUL2] = {
    name = "SUPER SOUL 2",
    ramp = {0,0,1,1,1,2,2,2,3,4,6,10,14,19,25,31
},
    invcolor = SKINCOLOR_SUPERCRIMSON4,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERSOUL3] = {
    name = "SUPER SOUL 3",
    ramp = {0,0,1,1,1,2,2,3,5,8,10,13,17,22,26,31
},
    invcolor = SKINCOLOR_SUPERCRIMSON3,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERSOUL4] = {
    name = "SUPER SOUL 4",
    ramp = {0,1,1,2,3,3,4,5,9,12,16,19,22,25,28,31
},
    invcolor = SKINCOLOR_SUPERCRIMSON2,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERSOUL5] = {
    name = "SUPER SOUL 5",
    ramp = {0,1,2,3,4,5,7,10,14,16,19,21,24,26,28,31
},
    invcolor = SKINCOLOR_SUPERCRIMSON1,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

skincolors[SKINCOLOR_SUPERCRIMSON1] = {
    name = "SUPER CRIMSON 1",
    ramp = {210,32,33,33,34,34,34,37,38,38,39,40,42,43,44,46
},
    invcolor = SKINCOLOR_SUPERSOUL5,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERCRIMSON2] = {
    name = "SUPER CRIMSON 2",
    ramp = {33,34,34,34,37,38,39,40,40,41,42,42,43,71,47,31
},
    invcolor = SKINCOLOR_SUPERSOUL4,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERCRIMSON3] = {
    name = "SUPER CRIMSON 3",
    ramp = {35,36,37,38,39,40,41,42,43,45,71,46,47,47,30,31
},
    invcolor = SKINCOLOR_SUPERSOUL3,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERCRIMSON4] = {
    name = "SUPER CRIMSON 4",
    ramp = {38,39,40,41,42,43,43,44,45,71,46,47,47,30,30,31
},
    invcolor = SKINCOLOR_SUPERSOUL2,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPERCRIMSON5] = {
    name = "SUPER CRIMSON 5",
    ramp = {41,42,42,43,44,44,45,71,46,46,47,47,47,30,30,31
},
    invcolor = SKINCOLOR_SUPERSOUL1,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
mobjinfo[MT_ELFILIN_FOLLOWMOBJ] = {
	doomednum = -1,
	spawnstate = S_PLAY_STND,
	dispoffset = 3,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ELFILIN_PORTAL] = {
	doomednum = -1,
	spawnstate = S_ELFILIN_PORTAL1,
	flags = MF_NOGRAVITY
}
mobjinfo[MT_ELFILIN_PORTAL_GHOST] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	dispoffset = -3,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ELFILIN_STAR] = {
	doomednum = -1,
	spawnstate = S_ELFILIN_STAR,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ELFILIN_SLOPEHELPER] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE
	--flags = MF_SCENERY
}
mobjinfo[MT_ELFILIN_SPEAR] = {
	doomednum = -1,
	spawnstate = S_ELFILIN_SPEAR,
	height = 125*FRACUNIT,
	radius = 10*FRACUNIT--,
	--flags = MF_SLIDEME
}
mobjinfo[MT_ELFILIN_CHAOSSPEAR_ORIGIN] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	height = 10*FRACUNIT,
	radius = 10*FRACUNIT,--,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ELFILIN_CHAOSSPEAR] = {
	doomednum = -1,
	spawnstate = S_ELFILIN_CHAOSSPEAR,
	height = 125*FRACUNIT,
	radius = 10*FRACUNIT--,
	--flags = MF_SLIDEME
}
mobjinfo[MT_ELFILIN_SPARKLEBALL] = {
	doomednum = -1,
	spawnstate = S_THOK,
	height = 10,
	radius = 10,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
}
mobjinfo[MT_ELFILIN_SPEAR_HITBOX] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	height = 125,
	radius = 55,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_MISSILE
}
mobjinfo[MT_JUMPBOOSTARROW] = {
	doomednum = -1,
	spawnstate = S_JUMPBOOSTARROW,
	height = 1,
	radius = 1,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ELFILIN_EMERALD] = {
	doomednum = -1,
	spawnstate = S_NULL,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
	radius = 5*FRACUNIT,
	height = 30*FRACUNIT,
}
states[S_ELFILIN_PORTAL1] = {
	sprite = SPR_EPT1,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE,
	var1 = 2,
	var2 = 2
}
local v1 = 24
states[S_ELFILIN_PORTAL2] = {
	sprite = SPR_EPT2,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE,
	var1 = v1,
	var2 = 2,
	tics = 2*v1,
	nextstate = S_ELFILIN_PORTAL3
}
states[S_ELFILIN_PORTAL3] = {
	sprite = SPR_EPT3,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE,
	var1 = 5,
	var2 = 2
}
states[S_ELFILIN_PORTALBACK1] = {
	sprite = SPR_EPB1,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE,
	var1 = v1,
	var2 = 2,
	tics = 2*v1,
	nextstate = S_ELFILIN_PORTAL3
}
states[S_ELFILIN_PORTALBACK2] = {
	sprite = SPR_EPB2,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE,
	var1 = 5,
	var2 = 2
}
states[S_JUMPBOOSTARROW] = {
	sprite = SPR_JMAR,
	frame = A|FF_FULLBRIGHT
}
states[S_ELFILIN_SPEAR] = {
	sprite = SPR_ELSP,
	frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
}
states[S_ELFILIN_CHAOSSPEAR] = {
	sprite = SPR_CHSP,
	frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE,
	tics = -1
}
states[S_ELFILIN_STAR] = {
	sprite = SPR_ELSR,
	frame = A|FF_FULLBRIGHT
}
states[S_PLAY_ELFILIN_TWIRL] = {
	sprite = SPR_PLAY,
	frame = SPR2_ROLL|FF_ANIMATE,
	nextstate = S_PLAY_WALK,
	var2 = 3,
	tics = 20
}
states[S_PLAY_ELFILIN_ATTACK] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE|FF_ANIMATE,
	nextstate = S_PLAY_WALK,
	var2 = 2
}
states[S_PLAY_ELFEYE] = {
	sprite = SPR_PLAY,
	frame = SPR2_TIRE
}
states[S_PLAY_ELFILIN_WALK] = {
	sprite = SPR_PLAY,
	frame = SPR2_WALK|FF_ANIMATE,
	tics = -1,
	var2 = 4
}
states[S_PLAY_ELFILIN_RUN] = {
	sprite = SPR_PLAY,
	frame = SPR2_RUN_|FF_ANIMATE,
	tics = -1,
	var2 = 3
}
states[S_PLAY_ELFILIN_STAND] = {
	sprite = SPR_PLAY,
	frame = SPR2_STND|FF_ANIMATE,
	tics = -1,
	var2 = 4
}
states[S_PLAY_ELFILIN_RIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_BNCE|FF_ANIMATE,
	tics = -1,
	var2 = 4
}
states[S_PLAY_ELFILIN_WAIT1] = {
	sprite = SPR_PLAY,
	frame = SPR2_WAIT|FF_ANIMATE,
	tics = 20*5,
	var2 = 5,
	nextstate = S_PLAY_ELFILIN_WAIT2
}
states[S_PLAY_ELFILIN_WAIT2] = {
	sprite = SPR_PLAY,
	frame = SPR2_GLID|FF_ANIMATE,
	tics = -1,
	var2 = 5
}
states[S_PLAY_ELFILIN_WAIT3] = {
	sprite = SPR_PLAY,
	frame = SPR2_CLNG,
	tics = -1
}
local function NewElfilinVars()
  return {
    storedmomz = 0,
    thokked = false,
    thokked2 = 0,
    jumped = false,
    lmao = false,
	hangtele = true,
    canflingportal = true,
    jumpdown = false,
    attack = 0,
    elftwirl = 0,
    jumpstartup = 0,
	attack_timer = 0,
    menuOpen = false,
    rollanglereset = false,
    sliding = false,
    rotangle = 1,
    Net_Freeze = "false",
    loweredgrav = 0,
	ridingplayer = 0,
	wdown = false,
	adown = false,
	sdown = false,
	ddown = false,
	jumpdownmp = false,
	spindownmp = false,
	voicenum = 0,
	c1down = false,
	jumpsquash = 0,
	spear = 0,
    spindown = false,
	idletimer = 0,
	idleboost = false,
	idlesquish = 0,
	idlerev = 0,
	idlebetween = 0,
	chaoseyes = 0,
	text = 0,
	textscale = 0,
	elfilis = 0,
	tcancel = 0
  }
end
addHook("PreThinkFrame", function(aeeaaeaeea)
	for p in players.iterate
		if p.mo and p.mo.valid and p.mo.skin == "elfilin"
			if not p.elfilin
				p.elfilin = NewElfilinVars()
			end
		else
			p.elfilin = nil
		end
	end
end)
addHook("PlayerSpawn", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "elfilin"
		p.elfilin = NewElfilinVars()
		P_SetOrigin(p.mo, p.mo.x, p.mo.y, p.mo.z+p.mo.scale*15*P_MobjFlip(p.mo))
	else
		p.elfilin = nil
	end
end)
local resetstate = {}
resetstate[S_PLAY_WALK] = true
resetstate[S_PLAY_RUN] = true
resetstate[S_PLAY_STND] = true
resetstate[S_PLAY_ELFILIN_WALK] = true
resetstate[S_PLAY_ELFILIN_RUN] = true
resetstate[S_PLAY_ELFILIN_STAND] = true
resetstate[S_PLAY_ELFILIN_WAIT1] = true
resetstate[S_PLAY_ELFILIN_WAIT2] = true
resetstate[S_PLAY_ELFILIN_WAIT3] = true
local attackstates = {}
attackstates[S_PLAY_ELFILIN_TWIRL] = true
attackstates[S_PLAY_ELFILIN_ATTACK] = true
attackstates[S_PLAY_ELFTRNS_1] = true
attackstates[S_PLAY_ELFTRNS_2] = true
attackstates[S_PLAY_ELFTRNS_3] = true
attackstates[S_PLAY_ELFTRNS_4] = true
attackstates[S_PLAY_ELFTRNS_5] = true
attackstates[S_PLAY_ELFTRNS_6] = true
attackstates[S_PLAY_ELFTRNS_7] = true
attackstates[S_PLAY_ELFTRNS_8] = true
attackstates[S_PLAY_ELFSTMP_1] = true
attackstates[S_PLAY_ELFSTMP_2] = true
attackstates[S_PLAY_ELFSTMP_3] = true
attackstates[S_PLAY_ELFSTMP_4] = true
attackstates[S_PLAY_ELFSTMP_5] = true
attackstates[S_PLAY_ELFSTMP_6] = true
attackstates[S_PLAY_ELFSTMP_7] = true
attackstates[S_PLAY_ELFSTMP_6_ALT] = true
attackstates[S_PLAY_ELFSTMP_7_ALT] = true
attackstates[S_PLAY_ELFSTMP_8] = true
attackstates[S_PLAY_ELFSTMP_9] = true
attackstates[S_PLAY_ELFSTMP_10] = true
attackstates[S_PLAY_ELFSTMP_11] = true
attackstates[S_PLAY_ELFSTMP_12] = true
attackstates[S_PLAY_ELFSTMP_END] = true
local idlestates = {}
idlestates[S_PLAY_ELFILIN_WAIT1] = true
idlestates[S_PLAY_ELFILIN_WAIT2] = true
idlestates[S_PLAY_ELFILIN_WAIT3] = true
local killmeplease = {}
killmeplease[S_PLAY_ELFSTMP_1] = true
killmeplease[S_PLAY_ELFSTMP_2] = true
killmeplease[S_PLAY_ELFSTMP_3] = true
killmeplease[S_PLAY_ELFSTMP_4] = true
killmeplease[S_PLAY_ELFSTMP_5] = true
killmeplease[S_PLAY_ELFSTMP_6] = true
killmeplease[S_PLAY_ELFSTMP_7] = true
killmeplease[S_PLAY_ELFSTMP_6_ALT] = true
killmeplease[S_PLAY_ELFSTMP_7_ALT] = true
killmeplease[S_PLAY_ELFSTMP_8] = true
killmeplease[S_PLAY_ELFSTMP_9] = true
killmeplease[S_PLAY_ELFSTMP_10] = true
killmeplease[S_PLAY_ELFSTMP_11] = true
killmeplease[S_PLAY_ELFSTMP_12] = true
killmeplease[S_PLAY_ELFSTMP_END] = true
local value = 0

--this game fucking sucks
addHook("ThinkFrame", function(e)
	for p in players.iterate
		if p and p.mo and p.mo.valid and p.mo.health and p.mo.skin == "elfilin"
			--print(states[p.mo.state])
			p.elfilin.sliding = (p.pflags & PF_SLIDING)
			--print(value)
			--local ammount = -5*FRACUNIT
			--if p.powers[pw_carry] == CR_PLAYER
				--P_TeleportMove(p.mo, p.mo.x+P_ReturnThrustX(p.mo, p.drawangle, ammount), p.mo.y+P_ReturnThrustY(p.mo, p.drawangle, ammount), p.mo.z+45*p.mo.scale)
			--end
		end
	end
end)

-- returns whether @sector is a death pit, assuming Elfilin is hovering over it (i.e. does not account for headbump pits)
local function SectorIsDeathPit(sector, player, fof)
    local special = GetSecSpecial(sector.special, 1)
    
    -- if this sector is not a death pit, that's all we need to know
    if special ~= 6 and special ~= 7
        return false
    end
    
    local flipped = player.mo.eflags & MFE_VERTICALFLIP
    local flags = sector.flags
    
    -- if the fof is intangible, planes don't matter, you always die inside it
    if fof
    and (fof.fofflags & FOF_BLOCKPLAYER)
        return true
    end
    
    -- if it is a death pit, check whether it affects the floor or ceiling
    return flipped and flags & MSF_FLIPSPECIAL_CEILING
    or not flipped and flags & MSF_FLIPSPECIAL_FLOOR
end

local chaoscolors = {
[S_CEMG1] = SKINCOLOR_MINT,
[S_CEMG2] = SKINCOLOR_BUBBLEGUM,
[S_CEMG3] = SKINCOLOR_SAPPHIRE,
[S_CEMG4] = SKINCOLOR_SKY,
[S_CEMG5] = SKINCOLOR_ORANGE,
[S_CEMG6] = SKINCOLOR_SALMON,
[S_CEMG7] = SKINCOLOR_AETHER,
}
addHook("PlayerThink", function(p)
	local playertrueangle = p.cmd.angleturn<<16 + R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, -p.cmd.sidemove*FRACUNIT)
	if (p.mo and p.mo.valid and p.mo.health and p.mo.skin == "elfilin")
		local elf = p.elfilin
		p.elfilin.jumpstartup = max($-1, 0)
		if not (p.elfilin.sliding) and not (p.powers[pw_carry] == CR_NIGHTSMODE)
			p.mo.friction = FRACUNIT
		end
		if modeattacking --temporary fix, remove when srb2 is updated to fix record attack camera behavior
			p.camerascale = FRACUNIT
		end
		if (p.powers[pw_carry] == CR_NIGHTSMODE) return end
		--spawn slope helper
		/*if (p.mo.elf_slopehelper and p.mo.elf_slopehelper.valid)
			P_RemoveMobj(p.mo.elf_slopehelper)
		end
		if not (p.mo.elf_slopehelper and p.mo.elf_slopehelper.valid)
			local shelp = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ELFILIN_SLOPEHELPER)
			shelp.radius = p.mo.radius
			shelp.height = p.mo.height
			shelp.scale = p.mo.scale
			shelp.target = p.mo
			shelp.state = S_PLAY_WALK
			print(shelp.standingslope)
			--shelp.fuse = 2
			P_TeleportMove(shelp, p.mo.x, p.mo.y, p.mo.floorz-p.mo.scale/2)
			p.mo.elf_slopehelper = shelp
		end*/
		
		--if (p.mo.elf_slopehelper) and (p.mo.elf_slopehelper.standingslope)
			--print(p.mo.elf_slopehelper.standingslope.zdelta)
		--end
		--print(EMERALD1|EMERALD2|EMERALD3|EMERALD4|EMERALD5|EMERALD6|EMERALD7)
		
		////////////////////////
		--Chaos Elfilin
		////////////////////////
		if (p.cmd.buttons & BT_SPIN) and (p.cmd.buttons & BT_JUMP) and (p.pflags & PF_STARTJUMP) and p.rings >= 50 and not (p.powers[pw_super]) and (p.powers[pw_emeralds] == 127 or All7Emeralds(emeralds)) and not (p.exiting)
			--P_DoSuperTransformation(p, false)
			--S_StopSound(p.mo)
			P_PlayJingleMusic(p, "TRUCK", nil, true, JT_SUPER)
			--S_StartSound(p.mo, sfx_s3k9f)
			S_StartSoundAtVolume(p.mo, sfx_s3k46, 128)
			p.powers[pw_super] = 1
			p.charflags = $|SF_SUPER
			p.mo.state = S_PLAY_RUN
			p.mo.state = S_PLAY_ELFTRNS_1
			p.amogusmcbogusstupidassvar = true
			/*local elfilis = P_SpawnMobjFromMobj(p.mo, 0, 0, 125*p.mo.scale, MT_ELFILISBALL)
			elfilis.scale = p.mo.scale
			elfilis.target = p.mo
			elfilis.lifetime = 0
			elfilis.blendmode = AST_ADD
			elfilis.spritexscale = FRACUNIT/2
			elfilis.spriteyscale = FRACUNIT/2
			elfilis.momz = -1*P_MobjFlip(p.mo)*p.mo.scale
			p.elfilin.elfilis = elfilis*/
			for i = 1, 7
				local e = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ELFILIN_EMERALD)
				e.state = S_CEMG1+(i-1)
				e.ang = FixedAngle((360*FRACUNIT)/7)
				e.target = p.mo
				e.i = i
				P_SetOrigin(e, p.mo.x+P_ReturnThrustX(e, e.ang*i, 60*p.mo.scale), p.mo.y+P_ReturnThrustY(e, e.ang*i, 60*p.mo.scale), p.mo.z)
			end
		end
		p.elfilin.tcancel = max(0, $-1)
		if (p.mo.state == S_PLAY_ELFTRNS_1)
			if (p.cmd.buttons & BT_JUMP) and not (p.amogusmcbogusstupidassvar)
				p.mo.state = S_PLAY_ELFTRNS_2
				S_StartSound(p.mo, sfx_supert)
				p.elfilin.tcancel = 1
			end
		end
		p.amogusmcbogusstupidassvar = (p.cmd.buttons & BT_JUMP)
		local dist = 1500
		if (p.powers[pw_super])
			if not ((p.elfilin.chaoseyes) and (p.elfilin.chaoseyes.valid) and (p.elfilin.chaoseyes.health))
				local eyes = P_SpawnMobjFromMobj(p.mo, p.mo.x, p.mo.y, p.mo.z, MT_ELFILIN_EYES)
				eyes.skin = p.mo.skin
				eyes.scale = p.mo.scale
				eyes.color = SKINCOLOR_RED
				eyes.target = p.mo
				p.elfilin.chaoseyes = eyes
			end
			if p.powers[pw_carry] == CR_ROLLOUT
				p.pflags = $&~PF_JUMPED&~PF_STARTJUMP&~PF_JUMPDOWN
				if (p.mo.state >= S_PLAY_ELFTRNS_1 and p.mo.state <= S_PLAY_ELFTRNS_8)
					p.mo.state = S_PLAY_WALK
				end
			end
			local sparkleammount
			if not (p.mo.state >= S_PLAY_ELFTRNS_1 and p.mo.state <= S_PLAY_ELFTRNS_7)
				if ELF_SPARKCOUNT <= 264
					sparkleammount = 10
					--CONS_Printf(p, "1")
				elseif ELF_SPARKCOUNT <= 600
					sparkleammount = 5
					--CONS_Printf(p, "2")
				else
					sparkleammount = 2
					--CONS_Printf(p, "3")
				end
				--CONS_Printf(p, ELF_SPARKCOUNT)
				for i = 0, sparkleammount do
					--print(i)
					local thok = P_SpawnMobjFromMobj(p.mo, P_RandomRange(dist, -dist)*p.mo.scale, P_RandomRange(dist, -dist)*p.mo.scale, P_RandomRange(dist/3, -dist/3)*p.mo.scale, MT_ELFILIN_SPARKLEBALL)
					thok.blendmode = AST_ADD
					thok.sprite = SPR_EBAL
					thok.frame = $|FF_FULLBRIGHT
					thok.colorized = true
					thok.color = chaoscolors[S_CEMG1+P_RandomRange(0, 6)]
					thok.scale = p.mo.scale
					thok.destscale = 0
					thok.scalespeed = p.mo.scale/40
					thok.tics = TICRATE-TICRATE/3
					thok.momz = p.mo.scale*P_MobjFlip(p.mo)
					ELF_SPARKCOUNT = $+1
				end
			end

			if (p.mo.state >= S_PLAY_ELFTRNS_1 and p.mo.state <= S_PLAY_ELFTRNS_8)
				--p.powers[pw_super] = min($, 1)
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0
				p.elfilin.idletimer = 0
				if (leveltime % TICRATE == 0)
					p.rings = $+1
				end
				if p.mo.state != S_PLAY_ELFTRNS_8
					p.mo.color = p.skincolor --:V 
				end
				if p.mo.state == S_PLAY_ELFTRNS_2
					if p.elfilin.text == 0
						p.elfilin.text = TICRATE*2
						p.elfilin.textscale = 0
					end
				end
				if p.mo.state == S_PLAY_ELFTRNS_6
					P_NukeEnemies(p.mo, p.mo, 70*p.mo.scale)
					P_FlashPal(p, PAL_WHITE, 3)
				end
				p.drawangle = -p.cmd.angleturn<<FRACBITS-FixedAngle(25*FRACUNIT)
				if p.elfilin.text == 1
					p.mo.state = S_PLAY_ELFILIN_WALK 
				end
			else
				searchBlockmap("objects", function(_, found)
					if found and found.valid and found.health and ((found.flags & MF_ENEMY) or (found.flags & MF_BOSS))
						--P_DamageMobj(found, p.mo, p.mo)
						--print(found)
						if not (found.spearspawner and found.spearspawner.valid)
							local sps = P_SpawnMobjFromMobj(found, found.x, found.y, found.z, MT_ELFILIN_CHAOSSPEAR_ORIGIN)
							sps.scale = found.scale
							sps.victim = found
							sps.target = p.mo
							found.spearspawner = sps
						end
					end
				end, p.mo, p.mo.x - dist*p.mo.scale, p.mo.x + dist*p.mo.scale, p.mo.y - dist*p.mo.scale, p.mo.y + dist*p.mo.scale)
			end
		else
			p.charflags = $&~SF_SUPER
		end
		if p.elfilin.text > 0
			p.elfilin.text = $-1
			p.elfilin.textscale = $+1
		end
		--print(p.powers[pw_super])
		
		
		
		--adjust thrustfactor depending on speed so that you can actually start moving without wanting to die
		if (FixedHypot(p.mo.momx, p.mo.momy) <= 10*p.mo.scale)
			p.thrustfactor = 10
		else
			p.thrustfactor = 5
		end
		--dont roll
		if not (p.powers[pw_carry])
			p.pflags = $&~PF_SPINNING
		end
		--print(p.elfilin.attack_timer)
		--rebound off of a floor if you have enough z momentum stored
		local waterdiv
		if (p.mo.eflags & MFE_UNDERWATER)
			waterdiv = 2
		else
			waterdiv = 1
		end
		if not (p.bot) and P_IsObjectOnGround(p.mo) and (p.elfilin.storedmomz*P_MobjFlip(p.mo) <= -8*p.mo.scale) and p.elfilin.jumpstartup == 0 and not (p.powers[pw_carry]) and not (p.elfilin.sliding)
			S_StartSound(p.mo, sfx_elfbnd)
			if p.elfilin.attack_timer == 0
				p.mo.momz = -(p.elfilin.storedmomz-p.elfilin.storedmomz/8)
			else
				p.mo.momz = 8*FRACUNIT*P_MobjFlip(p.mo)/waterdiv
				--P_InstaThrust(p.mo, R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x+p.mo.momx, p.mo.y+p.mo.momy), 26*FRACUNIT)
			end
			p.mo.state = S_PLAY_ELFILIN_TWIRL
			p.elfilin.elftwirl = p.drawangle
			p.elfilin.loweredgrav = 0
			if R_PointToAngle(p.mo.x, p.mo.y) - p.drawangle >= 0 then p.elfilin.rotangle = -1 else p.elfilin.rotangle = 1 end
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
			for i = 1, 10
				local star = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ELFILIN_STAR)
				star.scale = p.mo.scale/2
				star.fuse = TICRATE*9
				star.blendmode = AST_ADD
				P_InstaThrust(star, FixedAngle((360*FRACUNIT)/10)*i, 5*p.mo.scale)
				star.momz = 3*p.mo.scale*P_MobjFlip(p.mo)
				star.z = $ + P_MobjFlip(p.mo)
			end
		end
		if (p.mo.state == S_PLAY_ELFILIN_TWIRL)
			p.drawangle = p.elfilin.elftwirl
			--p.mo.rollangle = $+FixedAngle(360*FRACUNIT/20)*p.elfilin.rotangle
			--p.elfilin.elftwirl =$+FixedAngle(360*FRACUNIT/20)*p.elfilin.rotangle
			p.elfilin.rollanglereset = true
		elseif p.elfilin.rollanglereset
			p.elfilin.rollanglereset = false
			p.mo.rollangle = 0
		end
		
		--attack stuff
		--print((p.mo.state == S_PLAY_ELFSTMP_5))
		if killmeplease[p.mo.state] and P_IsObjectInGoop(p.mo)
			p.mo.state = S_PLAY_FALL
		end
		if p.elfilin.attack_timer and p.elfilin.attack_timer > 0
			if P_IsObjectOnGround(p.mo) or not attackstates[p.mo.state] or (p.powers[pw_carry])
				p.elfilin.attack_timer = 0
				p.elfilin.attack = 0
			else
				--p.elfilin.attack_timer = $+1
				if p.mo.state == S_PLAY_ELFSTMP_5
					p.elfilin.thokked2 = 2
				end
				if not (p.cmd.buttons & BT_JUMP)
					if (p.elfilin.spear and p.elfilin.spear.valid and p.mo.state == S_PLAY_ELFSTMP_5)
						--if p.mo.state < S_PLAY_ELFSTMP_6
							--p.elfilin.attack_timer = max($, floattime-9)
							p.mo.state = S_PLAY_ELFSTMP_6_ALT
							--p.mo.frame = 6
						--end
					elseif p.mo.state < S_PLAY_ELFSTMP_5 and (p.elfilin.spear and p.elfilin.spear.valid)
						p.elfilin.attack_timer = 0
						p.elfilin.spear.destscale = max (p.elfilin.spear.scale, p.mo.scale/2)
						p.mo.state = S_PLAY_FALL
						/*P_DoJump(p)
						p.pflags = $&~PF_STARTJUMP
						P_SetObjectMomZ(p.mo, 4*FRACUNIT, false)*/
					end
				end
				if p.mo.state == S_PLAY_ELFSTMP_END
					p.elfilin.attack_timer = max($, floattime)
				end
				if p.elfilin.attack_timer >= floattime
					p.elfilin.attack_timer = $+1
				end
				if p.elfilin.attack_timer < floattime
					if attackstates[p.mo.state]
						p.mo.momz = 0
					end
					--print(leveltime)
					P_Thrust(p.mo, R_PointToAngle2(p.mo.x+p.mo.momx, p.mo.y+p.mo.momy, p.mo.x, p.mo.y), FixedHypot(p.mo.momx, p.mo.momy)/21)
					if (p.mo.advanceelfanim)
						p.mo.advanceelfanim = false
						--p.mo.state = S_PLAY_ELFSTMP_2
					end
				elseif p.elfilin.attack_timer >= floattime
					if p.elfilin.attack_timer == floattime
						--p.mo.momx = $/2
						--p.mo.momy = $/2	
					end
					P_SetObjectMomZ(p.mo, min(p.mo.momz, -30*FRACUNIT), false)
					p.elfilin.attack = $-p.mo.scale/5
				end
			end
		else
			p.elfilin.attack = 0
		end	
		--spear atk zoom sound
		if p.mo.state == S_PLAY_ELFSTMP_8 and not (S_SoundPlaying(p.mo, sfx_zoom))
			S_StartSound(p.mo, sfx_zoom)
		end
		if (p.mo.state == S_PLAY_ELFSTMP_6 or p.mo.state == S_PLAY_ELFSTMP_6_ALT) and not (S_SoundPlaying(p.mo, sfx_elsp2))
			S_StartSound(p.mo, sfx_elsp2)
		end
		p.elfilin.lmao = false
        --floating above floors
        local sec, fof
        if p.mo.floorrover and P_MobjFlip(p.mo) == 1 and (p.mo.floorz-p.mo.z >= -12*p.mo.scale)
            fof = p.mo.floorrover
            sec = fof.sector
        elseif p.mo.ceilingrover and P_MobjFlip(p.mo) == -1 and (p.mo.ceilingz-(p.mo.z+p.mo.height) <= 12*p.mo.scale)
            fof = p.mo.ceilingrover
            sec = fof.sector
        else
            sec = p.mo.subsector.sector
        end
        if ((p.mo.floorz-p.mo.z >= -12*p.mo.scale) and P_MobjFlip(p.mo) == 1 or (p.mo.ceilingz-(p.mo.z+p.mo.height) <= 12*p.mo.scale) 
        and P_MobjFlip(p.mo) == -1) and not (p.powers[pw_carry]) and not (p.elfilin.sliding)
        and not (sec and SectorIsDeathPit(sec, p, fof) and (p.mo.floorz == sec.floorheight and P_MobjFlip(p.mo) == 1 or p.mo.ceilingz == sec.ceilingheight and P_MobjFlip(p.mo) == -1))
		
			--print(p.mo.floorz-p.mo.z)
			if (p.mo.momz*P_MobjFlip(p.mo) <= p.mo.scale*2-p.mo.scale/2) and not (P_IsObjectInGoop(p.mo)) and not attackstates[p.mo.state] and not (p.powers[pw_carry]) and not (p.elfilin.sliding) 
				if p.mo.state != S_PLAY_ELFILIN_WAIT2 and p.mo.state != S_PLAY_ELFILIN_WAIT3
					P_SetObjectMomZ(p.mo, FRACUNIT-FRACUNIT/8, true)
				end
				--elseif not p.elfilin.idleboost
				--	P_SetObjectMomZ(p.mo, FRACUNIT, false)
				--	p.elfilin.idleboost = true
				--end
			end
			p.elfilin.thokked = false
			p.elfilin.thokked2 = 0
			p.elfilin.jumped = false
			p.elfilin.canflingportal = true

			if p.mo.state != S_PLAY_ELFILIN_TWIRL
				p.elfilin.loweredgrav = TICRATE+TICRATE/3
			end
			p.elfilin.lmao = true
			p.pflags = $&~PF_JUMPED&~PF_STARTJUMP
		end
		if p.powers[pw_carry]
			p.elfilin.thokked = false
			p.elfilin.canflingportal = true
		end
		--if p.powers[pw_carry] == CR_PLAYER
			--if p.elfilin.hangtele == true
				---P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z+50*FRACUNIT)
				--p.elfilin.hangtele = false
			--end
			--`P_SetObjectMomZ(p.mo, 1, false)
		--else
			--p.elfilin.hangtele = true
		--end
		--print(p.elfilin.loweredgrav)
		--gravity shennanigans
		if not (P_IsObjectOnGround(p.mo) and idlestates[p.mo.state]) and not (p.powers[pw_carry]) and p.mo.momz != 0
			if P_MobjFlip(p.mo) == 1
				if idlestates[p.mo.state]
					p.mo.momz = $ - ((P_GetMobjGravity(p.mo)/2)+P_GetMobjGravity(p.mo)/3)
				else
					if (p.elfilin.loweredgrav)
						p.mo.momz = $ - ((P_GetMobjGravity(p.mo)/2)+P_GetMobjGravity(p.mo)/4)
					else--if not (p.elfilin.jumped)
						p.mo.momz = $ - ((P_GetMobjGravity(p.mo)/2)-P_GetMobjGravity(p.mo)/11)
					--else
						--p.mo.momz = $ - P_GetMobjGravity(p.mo)/3
					end
				end
			else
				if idlestates[p.mo.state]
					p.mo.momz = $ - ((P_GetMobjGravity(p.mo)/2)+P_GetMobjGravity(p.mo)/3)
				else
					if (p.elfilin.loweredgrav)
						p.mo.momz = $ - ((P_GetMobjGravity(p.mo)/2)+P_GetMobjGravity(p.mo)/4)
					else--if not (p.elfilin.jumped)
						p.mo.momz = $ - ((P_GetMobjGravity(p.mo)/2)-P_GetMobjGravity(p.mo)/11)
					--else
						--p.mo.momz = $ - P_GetMobjGravity(p.mo)/3
					end		
				end
			end
		end
		if p.elfilin.loweredgrav > 0
			p.elfilin.loweredgrav = $-1
		end
		if (p.pflags & PF_JUMPED)
			p.elfilin.loweredgrav = 0
		end

		--slow down when inputs are neutral and you're below a certain speed so stopping is actually possible
		--also idle animation
		if p.cmd.forwardmove == 0 and p.cmd.sidemove == 0
		and not (p.powers[pw_carry]) and not (p.elfilin.sliding)
		and FixedHypot(p.mo.momx, p.mo.momy) <= 16*p.mo.scale
			--print(leveltime)
			if FixedHypot(p.mo.momx, p.mo.momy) >= p.mo.scale/2
				P_Thrust(p.mo, R_PointToAngle2(p.mo.x+p.mo.momx, p.mo.y+p.mo.momy, p.mo.x, p.mo.y), p.mo.scale/15)
				p.elfilin.idletimer = 0
				p.elfilin.idleboost = false
			else
				if leveltime % 2 == 0 --fuck you autoturn
					p.mo.momx = 1
				else
					p.mo.momx = -1
				end
				p.mo.momy = 0
				p.elfilin.idletimer = $+1
				if (p.cmd.buttons & BT_CUSTOM2)
					p.elfilin.idletimer = max($, IDLETIME)
				end
				if p.elfilin.idletimer >= IDLETIME
					if p.elfilin.idletimer == IDLETIME
						p.mo.state = S_PLAY_ELFILIN_WAIT1
					end
					if p.mo.state == S_PLAY_ELFILIN_WAIT2
						p.panim = PA_DASH
						if p.mo.momz*P_MobjFlip(p.mo) <= -p.mo.scale
							P_SetObjectMomZ(p.mo, (p.mo.momz*P_MobjFlip(p.mo)*-1)/6, true)
						end
						if P_IsObjectOnGround(p.mo)
							p.mo.state = S_PLAY_ELFILIN_WAIT3
							p.elfilin.idlesquish = TICRATE*2
						end
					end
				end
			end
		else
			p.elfilin.idletimer = 0
			p.elfilin.idleboost = false
		end
		if p.mo.state == S_PLAY_ELFILIN_WAIT3
			if p.elfilin.idlerev == 0
				p.elfilin.idlerev = -1
			end
			if p.elfilin.idlesquish <= TICRATE-TICRATE/4
				p.mo.spriteyscale = $+(FRACUNIT/95)*p.elfilin.idlerev
				p.mo.spritexscale = $-(FRACUNIT/135)*p.elfilin.idlerev
			else
				p.elfilin.idlebetween = $+1
			end
			if p.elfilin.idlebetween == TICRATE-TICRATE/4
				p.elfilin.idlebetween = 0
				p.elfilin.idlesquish = 0
				p.elfilin.idlerev = $*-1
				if p.elfilin.idlerev == 1
					S_StartSound(p.mo, sfx_elslp1)
				else
					S_StartSound(p.mo, sfx_elslp2)
				end
			end
			p.elfilin.idlesquish = $+1
		elseif p.elfilin.idlerev != 0
			p.elfilin.idlesquish = 0
			p.elfilin.idlerev = 0
			p.elfilin.idlebetween = 0
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end

		--print(p.elfilin.idletimer)
		--halt player when in menus
		--if p.elfilin.Net_Freeze == "true"
			--if not (p.pflags & PF_JUMPED) and not (p.powers[pw_carry])
				--p.mo.momx = 0
				--p.mo.momy = 0
				--p.mo.momz = 0
				--p.rmomx = 0
				--p.rmomy = 0
				--p.rmomz = 0
				--p.jointime = TICRATE*4
			--end
		--end
		if p == consoleplayer
			if p.elfilin.menuOpen != menuactive
				COM_BufInsertText(p, "commandthatdoesimportantthings \B6 " .. tostring(menuactive))
			end
			p.elfilin.menuOpen = menuactive
		end
		--animations
		if (resetstate[p.mo.state] or p.elfilin.lmao and not attackstates[p.mo.state])-- and not idlestates[p.mo.state]
			if FixedHypot(p.mo.momx, p.mo.momy) > 20*p.mo.scale
				if p.mo.state != S_PLAY_ELFILIN_RUN
					p.mo.state = S_PLAY_ELFILIN_RUN
				end
			elseif FixedHypot(p.mo.momx, p.mo.momy) > 7*p.mo.scale or (p.cmd.forwardmove != 0 or p.cmd.sidemove != 0)
				if p.mo.state != S_PLAY_ELFILIN_WALK
					p.mo.state = S_PLAY_ELFILIN_WALK
				end
			elseif not idlestates[p.mo.state]
				if p.mo.state != S_PLAY_ELFILIN_STAND
					p.mo.state = S_PLAY_ELFILIN_STAND
				end
			end
			p.panim = PA_DASH
		end
		
		if p.powers[pw_carry] == CR_MACESPIN
			p.elfilin.thokked = true
			p.elfilin.thokked2 = 0
		end
		--jumping
		if (p.cmd.buttons & BT_JUMP) and not (p.elfilin.jumpdown) and not (p.elfilin.thokked) and not (p.elfilin.ridingplayer) and not (p.powers[pw_carry])
			p.elfilin.thokked = true
			p.elfilin.thokked2 = 0
			p.elfilin.jumped = true
			p.elfilin.jumpstartup = 3
			--P_SetObjectMomZ(p.mo, 8*FRACUNIT, false)
			P_DoJump(p)
			p.elfilin.idletimer = 0
			p.elfilin.idleboost = false
			p.elfilin.jumpsquash = 4
			p.mo.momz = $-$/4
			p.pflags = $|PF_STARTJUMP|PF_JUMPED
			--print("test")
		end
		if (p.elfilin.jumpstartup > 0)
			p.pflags = $|PF_STARTJUMP|PF_JUMPED
			p.elfilin.thokked = true
			p.elfilin.thokked2 = 0
			p.elfilin.jumped = true
			if p.mo.state != S_PLAY_JUMP
				p.mo.state = S_PLAY_JUMP
			end
		end
		local squashvars = {}
		squashvars[4] = {FRACUNIT+FRACUNIT/8, FRACUNIT-FRACUNIT/11}
		squashvars[3] = {FRACUNIT+FRACUNIT/5, FRACUNIT-FRACUNIT/8}
		--squashvars[3] = {FRACUNIT+FRACUNIT/6, FRACUNIT-FRACUNIT/7}
		--squashvars[3] = {FRACUNIT+FRACUNIT/2, FRACUNIT-FRACUNIT/7}
		squashvars[2] = {FRACUNIT+FRACUNIT/9, FRACUNIT-FRACUNIT/14}
		squashvars[1] = {FRACUNIT, FRACUNIT}
		if (p.elfilin.jumpsquash > 0)
			p.mo.spriteyscale = squashvars[p.elfilin.jumpsquash][1]
			p.mo.spritexscale = squashvars[p.elfilin.jumpsquash][2]
			p.elfilin.jumpsquash = $-1
		end
		if p.powers[pw_super]
			p.elfilin.canflingportal = true
		end
		--portal throwing & teleporting
		if (p.cmd.buttons & BT_SPIN) and not (p.elfilin.spindown) and not (p.elfilin.ridingplayer) and not (p.mo.state >= S_PLAY_ELFTRNS_1 and p.mo.state <= S_PLAY_ELFTRNS_8) and not (p.powers[pw_carry])
			if not (p.mo.elfilin_portal and p.mo.elfilin_portal.valid)
				if (p.elfilin.canflingportal)
					if (p.mo.elfilin_lastportal and p.mo.elfilin_lastportal.valid)
						P_SpawnGhostMobj(p.mo.elfilin_lastportal)
						P_RemoveMobj(p.mo.elfilin_lastportal)
						--print(leveltime)
					end
					local portal = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ELFILIN_PORTAL)
					portal.height = p.mo.height
					portal.radius = p.mo.radius
					portal.scale = p.mo.scale
					portal.spritexscale = FRACUNIT+FRACUNIT/2
					portal.spriteyscale = FRACUNIT+FRACUNIT/2
					--portal.state = S_RING
					portal.slowthefuckdown = 15
					portal.target = p.mo
					portal.fuse = TICRATE*10
					portal.angle = p.mo.angle+FixedAngle(90*FRACUNIT)
					p.mo.elfilin_portal = portal
					--print(leveltime)
					--if (p.cmd.forwardmove != 0 or p.cmd.sidemove != 0)
						P_InstaThrust(portal, p.mo.angle, horizontalflingspeed*p.mo.scale)
						P_SetObjectMomZ(portal, verticalflingspeed*FRACUNIT, false)
						p.elfilin.canflingportal = false
					S_StartSound(p.mo, sfx_nbmper)
					--else
						--P_SetObjectMomZ(portal, 22*FRACUNIT, false)
					--end
				end
			else
				p.mo.elfilin_portal.fuse = max($, 5*TICRATE)
				local portal = P_SpawnMobjFromMobj(p.mo, 0, 0, 20*p.mo.scale*P_MobjFlip(p.mo), MT_ELFILIN_PORTAL)
				portal.height = p.mo.height
				portal.radius = p.mo.radius
				portal.scale = p.mo.scale
				portal.otherportal = p.mo.elfilin_portal
				p.mo.elfilin_portal.otherportal = portal
				portal.spritexscale = FRACUNIT*2+FRACUNIT/2
				portal.spriteyscale = FRACUNIT*2+FRACUNIT/2
				--portal.state = S_RING
				portal.slowthefuckdown = 0
				p.mo.elfilin_portal.slowthefuckdown = 0
				portal.owner = p.mo
				portal.target = p.mo.elfilin_portal
				portal.fuse = p.mo.elfilin_portal.fuse
				portal.anim_duration = 1
				portal.angle = R_PointToAngle2(portal.x, portal.y, p.mo.elfilin_portal.x, p.mo.elfilin_portal.y)+FixedAngle(90*FRACUNIT)
				--p.mo.angle = R_PointToAngle2(p.mo.x, p.mo.y, p.mo.elfilin_portal.x, p.mo.elfilin_portal.y)
				P_SetOrigin(p.mo, p.mo.elfilin_portal.x, p.mo.elfilin_portal.y, p.mo.elfilin_portal.z)
				--P_TeleportCameraMove(camera, p.mo.elfilin_portal.x, p.mo.elfilin_portal.y, p.mo.elfilin_portal.z)
				--P_RemoveMobj(p.mo.elfilin_portal)
				--if p == consoleplayer
					p.mo.startransitionlifetimer = 1
				--end
				local playertrueangle = p.cmd.angleturn<<16 + R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, -p.cmd.sidemove*FRACUNIT)
				if p.speed < 6*p.mo.scale
					P_InstaThrust(p.mo, playertrueangle, 6*p.mo.scale)
				end
				S_StartSound(p.mo, sfx_prloop)
				--p.mo.elfilin_portal = portal
				p.elfilin.jumped = false
				p.elfilin.thokked = false
				p.elfilin.thokked2 = 0
				p.mo.elfilin_lastportal = p.mo.elfilin_portal
				p.mo.elfilin_portal.angle = R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x+p.mo.momx, p.mo.y+p.mo.momy)+FixedAngle(90*FRACUNIT)
				p.mo.elfilin_portal.hurryup = true
				p.mo.elfilin_portal = nil
				p.pflags = $&~PF_JUMPED&~PF_STARTJUMP
				if (p.mo.state == S_PLAY_JUMP) or idlestates[p.mo.state]
					p.mo.state = S_PLAY_ELFILIN_RUN
				end
				--P_FlashPal(p, 2, 5)
			end
		end
		p.elfilin.storedmomz = p.mo.momz
		p.elfilin.jumpdown = (p.cmd.buttons & BT_JUMP)
		p.elfilin.spindown = (p.cmd.buttons & BT_SPIN)
		--print(p.elfilin.attack)
		--print(p.elfilin.attack_timer)
		--P_RemoveMobj(p.mo.elf_slopehelper)
	end
end)
addHook("MobjRemoved", function(mo)
	ELF_SPARKCOUNT = $-1
end, MT_ELFILIN_SPARKLEBALL)
addHook("MapLoad", do
	ELF_SPARKCOUNT = 0
end)
local finalscale = FRACUNIT-FRACUNIT/3
local scale
local transmap = {}
transmap[5] = V_10TRANS
transmap[4] = V_30TRANS
transmap[3] = V_50TRANS
transmap[2] = V_70TRANS
transmap[1] = V_90TRANS
hud.add(function(v, player, cam)
	if player.mo and player.mo.valid and player.mo.health and (player.mo.skin == "elfilin" and player.elfilin and player.elfilin.text > 0)
		scale = min((finalscale/13)*player.elfilin.textscale, finalscale)
		if transmap[player.elfilin.text]
			v.drawScaled(160*FRACUNIT, 40*FRACUNIT, scale, v.cachePatch("SUPRELF"), V_SNAPTOTOP|transmap[player.elfilin.text])
		else
			v.drawScaled(160*FRACUNIT, 40*FRACUNIT, scale, v.cachePatch("SUPRELF"), V_SNAPTOTOP)
		end
	end
end, "game")
addHook("MobjThinker", function(mo)
	if mo.target and mo.target.valid and mo.target.health and mo.target.skin == "elfilin" and (mo.target.state >= S_PLAY_ELFTRNS_1 and mo.target.state <= S_PLAY_ELFTRNS_8) and (mo.target.player.elfilin)  and not (mo.target.player.elfilin.tcancel)
		mo.scale = mo.target.scale
		--mo.spritexscale = FRACUNIT/4+sin(ANG30*mo.lifetime)
		--mo.spriteyscale = FRACUNIT/4+sin(ANG30*mo.lifetime)
		mo.spritexoffset = 9*cos(ANG10*mo.lifetime)
		P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.z)
		mo.lifetime = $+1
		if mo.lifetime == 79
			S_StartSound(mo.target, sfx_supert)
			--S_StartSound(mo.target, sfx_s3k9f)
			--S_StartSound(mo.target, sfx_s3k46)
			mo.target.state = S_PLAY_ELFTRNS_2
			local g = P_SpawnGhostMobj(mo)
			g.blendmode = AST_ADD
			g.spritexscale = mo.spritexscale
			g.spriteyscale = mo.spriteyscale
			g.spritexoffset = mo.spritexoffset
			g.dispoffset = 6
			P_RemoveMobj(mo)
			return
		end
		--if mo.lifetime % 15 == 0
			--S_StartSound(mo, sfx_esoul2)
		--end
		mo.momz = -(P_MobjFlip(mo.target)*mo.target.scale+mo.target.scale/2-mo.target.scale/9)
		--if (players[0].cmd.buttons & BT_CUSTOM2)
			--print(mo.lifetime)
			--P_RemoveMobj(mo)
		--end
	else
		P_RemoveMobj(mo)
	end
end, MT_ELFILISBALL)
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health and mo.target and mo.target.valid and mo.target.health
		if mo.victim and mo.victim.valid and mo.victim.health
			P_MoveOrigin(mo, mo.victim.x, mo.victim.y, mo.victim.z+200*mo.victim.scale)
			if not (mo.spear and mo.spear.valid and mo.health and mo.spear.lifetime < 3*TICRATE+TICRATE/3) and not (mo.victim.flags & MF2_FRET) and (mo.target.player.powers[pw_super])
				local spear = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_ELFILIN_CHAOSSPEAR)
				spear.target = mo
				spear.origin = mo.target
				spear.scale = mo.scale/20
				spear.destscale = mo.scale
				spear.scalespeed = FRACUNIT/20
				spear.spritexscale = FRACUNIT+FRACUNIT/3
				spear.spriteyscale = FRACUNIT+FRACUNIT/3
				spear.lifetime = 0
				S_StartSound(mo, sfx_elsp3)
				mo.spear = spear
				mo.angle = FixedAngle((leveltime % 180)*FRACUNIT)
			end
		else
			P_RemoveMobj(mo)
		end
	end
end, MT_ELFILIN_CHAOSSPEAR_ORIGIN)
local spearfade = {}
spearfade[1] = FF_TRANS90
spearfade[2] = FF_TRANS70
spearfade[3] = FF_TRANS60
spearfade[4] = FF_TRANS40
spearfade[5] = FF_TRANS30
spearfade[6] = FF_TRANS10
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health and mo.origin and mo.origin.valid and mo.origin.health
		if mo.lifetime < TICRATE*2+TICRATE/2
			if mo.target and mo.target.valid and mo.target.health --sanity check
				P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
			end
			mo.angle = $+FixedAngle(22*FRACUNIT)
			mo.momz = 0
		elseif mo.lifetime == TICRATE*2+TICRATE/2
			P_SetObjectMomZ(mo, -45*FRACUNIT, false)
			mo.fuse = TICRATE*3
		elseif not (P_IsObjectOnGround(mo))
			P_SpawnGhostMobj(mo)
		end
		if spearfade[mo.fuse]
			mo.frame = $|spearfade[mo.fuse]
		end
		mo.lifetime = $+1
	end
end, MT_ELFILIN_CHAOSSPEAR)
local function collZCheck(m,n) return m.z < n.z+n.height and m.z+m.height > n.z end

addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.health and thing and thing.valid and thing.health and (thing.flags & MF_ENEMY or thing.flags & MF_BOSS) and collZCheck(tmthing, thing) and tmthing.target and tmthing.target.valid
		if not (thing.speardamaged and thing.speardamaged == tmthing) and tmthing.lifetime >= TICRATE*2+TICRATE/2
			thing.speardamaged = tmthing
			if (tmthing.target and tmthing.target.valid and tmthing.target.target and tmthing.target.target.valid)
				P_DamageMobj(thing, tmthing, tmthing.target.target, 1)
			end
			S_StartSound(tmthing, sfx_kc41)
			if tmthing.target and tmthing.target.valid -- i hate errors
				if R_PointToDist(tmthing.x, tmthing.y) <= 2300*tmthing.target.scale
					P_StartQuake(FRACUNIT*5, 15)
				end
			end
		end
	end
end, MT_ELFILIN_CHAOSSPEAR)
/*addHook("MusicChange", function(oldname, newname)
	if consoleplayer
		local character = skins[consoleplayer.skin].name
		if character == "elfilin" //skin to use custom themes
		--print(newname)
			if newname == "_super" //intercept and override jingles
				return "TRUCK"
			end
		end
	end
end)*/


addHook("NetVars", function(net)
	ElfEyes = net(ElfEyes)
	ELF_SPARKCOUNT = net(ELF_SPARKCOUNT)
end)

addHook("MapChange", do
	ElfEyes = {}
end)

addHook("MobjSpawn", function(mo)
	table.insert(ElfEyes, mo)
end, MT_ELFILIN_EYES)


local eyeequiv = {}
eyeequiv[SPR2_STND] = 0
eyeequiv[SPR2_BNCE] = 0
eyeequiv[SPR2_WALK] = 1
eyeequiv[SPR2_RUN_] = 2
eyeequiv[SPR2_SPNG] = 3
eyeequiv[SPR2_GASP] = 3
eyeequiv[SPR2_FALL] = 4
eyeequiv[SPR2_RIDE] = 5
eyeequiv[SPR2_PAIN] = 6
local altequiv = {}
altequiv[SPR2_WAIT] = SPR2_TAL0
altequiv[SPR2_GLID] = SPR2_TAL1
altequiv[SPR2_CLNG] = SPR2_TAL2
altequiv[SPR2_MLEE] = SPR2_TAL3
altequiv[SPR2_MLEL] = SPR2_TAL4
addHook("PostThinkFrame", function()
	for i = #ElfEyes, 1, -1
		local mobj = ElfEyes[i]
		if not mobj.valid
			table.remove(ElfEyes, i)
			continue
		end
		if mobj and mobj.target and mobj.target.valid and mobj.target.health and mobj.target.player.powers[pw_super] and mobj.target.skin == "elfilin"
			if P_MobjFlip(mobj.target) == 1
				P_MoveOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z)
			else
				P_MoveOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z+mobj.target.height)
			end
			mobj.skin = "elfilin"
			if mobj.state != S_PLAY_ELFEYE
				mobj.state = S_PLAY_ELFEYE
			end
			if P_MobjFlip(mobj.target) == 1
				mobj.eflags = $&~MFE_VERTICALFLIP
			else
				mobj.eflags = $|MFE_VERTICALFLIP
			end
			mobj.spritexscale = mobj.target.spritexscale
			mobj.spriteyscale = mobj.target.spriteyscale
			mobj.rollangle = mobj.target.rollangle
			mobj.scale = mobj.target.scale
			mobj.angle = mobj.target.player.drawangle
			--mo.color = (SKINCOLOR_SUPERSILVER1 +5*((leveltime >> 1) % 7))
			if mobj.target.state == S_PLAY_ELFTRNS_8
				mobj.sprite2 = SPR2_TAL5
				mobj.frame = 0|FF_FULLBRIGHT
			elseif idlestates[mobj.target.state] or (killmeplease[mobj.target.state] and mobj.target.state != S_PLAY_ELFSTMP_END)
				mobj.sprite2 = altequiv[mobj.target.sprite2]
				mobj.frame = mobj.target.frame|FF_FULLBRIGHT
			elseif eyeequiv[mobj.target.sprite2] != nil
				mobj.sprite2 = SPR2_TIRE
				mobj.frame = eyeequiv[mobj.target.sprite2]|FF_FULLBRIGHT
				--mo.flags2 = $&~MF2_DONTDRAW
			else
				mobj.state = S_INVISIBLE
			end
		else
			table.remove(ElfEyes, i)
			P_RemoveMobj(mobj)
		end
	end
end)
addHook("PostThinkFrame", do

end)
addHook("PlayerCanDamage", function(p)
	if not (p.mo and p.mo.valid and p.mo.health and p.mo.skin == "elfilin") return end
	if not (p.elfilin.attack and p.elfilin.attack != 0) return end
	p.elfilin.thokked2 = 0
	return true
end)
addHook("AbilitySpecial", function(p)
	if not (p.mo and p.mo.valid and p.mo.health and p.mo.skin == "elfilin") return end
	if (p.elfilin.thokked2 >= 2) return end
	if (p.elfilin.ridingplayer) return end
	if P_IsObjectInGoop(p.mo) return end
	if (p.mo.state >= S_PLAY_ELFTRNS_1 and p.mo.state <= S_PLAY_ELFTRNS_8) return end
	local spear = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ELFILIN_SPEAR)
	spear.target = p.mo
	spear.scale = p.mo.scale/20
	spear.destscale = p.mo.scale
	spear.scalespeed = FRACUNIT/20
	if p.powers[pw_super]
		spear.state = S_ELFILIN_CHAOSSPEAR
	end
	S_StartSound(p.mo, sfx_elsp1)
	p.mo.state = S_PLAY_ELFSTMP_1
	p.elfilin.attack = -35*p.mo.scale
	p.elfilin.spear = spear
	p.elfilin.attack_timer = 1
	p.elfilin.thokked2 = $+1
end)
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health
		mo.lifetime = $ or 0
		mo.lifetime = $+1
		if P_IsObjectOnGround(mo) and mo.lifetime > 3
			local ghost = P_SpawnGhostMobj(mo)
			ghost.blendmode = AST_ADD
			P_RemoveMobj(mo)
		end
	end
end, MT_ELFILIN_STAR)
/*addHook("MobjThinker", function(mo)
	if (mo.target and mo.target.valid and mo.target.health and mo.target.skin == "elfilin")
		mo.state = S_PLAY_WALK
		P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.floorz)
		--mo.target.elf_slope = mo.standingslope
	else
		P_RemoveMobj(mo)
	end
end, MT_ELFILIN_SLOPEHELPER)*/
local amogues = 0
local function collZCheck2(m,n) return m.z < n.z+n.height*5 and m.z+m.height*5 > n.z end
addHook("MobjThinker", function(mo)
	if (mo.target and mo.target.valid and mo.target.health) and not (mo.fuse == 1)
		mo.slowthefuckdown = max($-1, 0)
		if mo.otherportal and mo.otherportal.valid
			for p in players.iterate
				if p and p.mo and p.mo.valid and p.mo.health
					if R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) <= 90*FRACUNIT and collZCheck2(p.mo, mo) and (p.mo != mo.target and (p.mo != mo.owner))
						p.portalnotif = 1
						p.availableportal = mo.otherportal
					end
				end
			end
		end
		if mo.slowthefuckdown == 0
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			if mo.state == S_ELFILIN_PORTAL1
				mo.state = S_ELFILIN_PORTAL2
			end
			if mo.state == S_ELFILIN_PORTAL2 and (mo.frame & FF_FRAMEMASK) > T
				--print(mo.tics)
				mo.spritexscale = $+FRACUNIT/4
				mo.spriteyscale = $+FRACUNIT/4
				amogues = $+1
			end
			if (mo.hurryup or mo.target.hurryup) and mo.state == S_ELFILIN_PORTAL2 and (mo.frame & FF_FRAMEMASK) < T
				mo.frame = (T & FF_FRAMEMASK)|FF_ANIMATE|FF_FULLBRIGHT|FF_PAPERSPRITE
				mo.tics = 8
			end
			if mo.state == S_ELFILIN_PORTAL3 or mo.state == S_ELFILIN_PORTAL2 and (mo.frame & FF_FRAMEMASK) > V 
				local ghost = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_ELFILIN_PORTAL_GHOST)
				ghost.fuse = 4
				ghost.spritexoffset = mo.spritexoffset+P_RandomRange(2, -2)*FRACUNIT
				ghost.spriteyoffset = mo.spriteyoffset+P_RandomRange(2, -2)*FRACUNIT
				ghost.blendmode = AST_ADD
				ghost.color = SKINCOLOR_COBALT
				ghost.colorized = true			
				ghost.dispoffset = -3
				ghost.state = mo.state+2
				ghost.frame = mo.frame&~FF_ANIMATE
				ghost.spritexscale = mo.spritexscale
				ghost.spriteyscale = mo.spriteyscale
				ghost.target = mo
				ghost.angle = mo.angle
			end
		end
		--print(amogues)
	else
		P_SpawnGhostMobj(mo)
		P_RemoveMobj(mo)
	end
end, MT_ELFILIN_PORTAL)
addHook("PlayerThink", function(p)
	if p and p.mo and p.mo.valid and p.mo.health
		if (p.cmd.buttons & BT_CUSTOM3 and not (p.elfportalc3down)) and (p.availableportal and p.availableportal.valid)
			P_SetOrigin(p.mo, p.availableportal.x, p.availableportal.y, p.availableportal.z)
			S_StartSound(p.mo, sfx_prloop)
			p.mo.startransitionlifetimer = 1
			p.elfportalc3down = true
			--print(leveltime)
		end
		--print(p.starpostnum)
		p.availableportal = nil
		if p.portalnotif
			p.portalnotif = max($-1, 0)
		end
		if (p.waselfilin) and p.mo.skin != "elfilin"
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
			if p.elfilin
				p.elfilin.idletimer = 0
			end
			if p.mo.state == S_PLAY_ELFILIN_WAIT3
				p.mo.state = S_PLAY_STND
			end
		end
		p.elfportalc3down = (p.cmd.buttons & BT_CUSTOM3)
		p.waselfilin = (p.mo.skin == "elfilin")
	end
end)
hud.add(function(v, player, cam)
	if player.mo and player.mo.valid and player.mo.health and (player.portalnotif)
		v.drawString(160, 180, "C3", V_YELLOWMAP|V_SNAPTOBOTTOM, "center")
		v.drawString(160, 190, "Teleport", V_AQUAMAP|V_SNAPTOBOTTOM, "center")
	end
end, "game")
addHook("MobjThinker", function(mo)
	if (mo.target and mo.target.valid and mo.target.health)
		if mo.state != mo.target.state+2
			mo.state = mo.target.state+2
		end
		mo.frame = mo.target.frame
	else
		P_RemoveMobj(mo)
	end
end, MT_ELFILIN_PORTAL_GHOST)
local function CheckAndCrumble2(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

/*addHook("PlayerThink", function(p)
  if not p.mo return end
  if p.mo.skin != "fp2lilac" return end
  if not (attackstates[p.mo.state]) return end
	CheckAndCrumble2(p.mo, p.mo.subsector.sector)
end)*/

addHook("MobjThinker", function(mo)
	if (mo.target and mo.target.valid and mo.target.health and mo.target.player and mo.target.skin == "elfilin")
		mo.didfunnyalready = $ or false
		CheckAndCrumble2(mo, mo.subsector.sector)
		if (mo.frame & FF_FRAMEMASK) == Y
			mo.tics = min($, 2)
		end
		if (P_IsObjectOnGround(mo) or not attackstates[mo.target.state]) and mo.target.player.elfilin.attack_timer == 0 or (mo.thefunny)
			if not (mo.thefunny)
				mo.thefunny = true
				mo.fuse = TICRATE*8
				if P_IsObjectInGoop(mo.target) --unnecessary but it looks cool so idc
					mo.momz = mo.target.momz
					mo.momx = mo.target.momx
					mo.momy = mo.target.momy
				end
			end
			if mo.fuse == 2
				P_SpawnGhostMobj(mo)
			end
		else
			--if P_MobjFlip(mo.target) == 1
				P_MoveOrigin(mo, mo.target.x, mo.target.y, max(mo.target.z-mo.target.scale*65, mo.target.floorz))
			--else
				--P_MoveOrigin(mo, mo.target.x, mo.target.y, min(mo.target.z+mo.target.height+mo.target.scale*65, mo.target.ceilingz))
			--end
			mo.momz = 0
			if mo.target.player.elfilin.attack_timer < floattime
				mo.angle = $+FixedAngle(22*FRACUNIT)
			end
			--mo.shadowscale = FRACUNIT
		end
		if mo.scale == mo.target.scale and not (mo.didfunnyalready)
			mo.didfunnyalready = true
			mo.target.advanceelfanim = true
		end
		local dist = 100
		local vertdist = 200
		if mo.scale == mo.target.scale or mo.target.player.elfilin.attack_timer > floattime
			searchBlockmap("objects", function(_, found)
				if found and found.valid and found.health and collZCheck(mo, found)
					P_DamageMobj(found, mo.target, mo.target)
					--print(found)
				end
			end, mo, mo.x - dist*mo.scale, mo.x + dist*mo.scale, mo.y - dist*mo.scale, mo.y + dist*mo.scale)
		end
	else
		P_SpawnGhostMobj(mo)
		P_RemoveMobj(mo)
	end
end, MT_ELFILIN_SPEAR)
/*COM_AddCommand("commandthatdoesimportantthings", function(p, key, arg) --stupid problems require stupid solutions
	if p and p.mo and p.mo.valid and p.mo.health and p.mo.skin == "elfilin" and p.elfilin and multiplayer and (gametyperules & GTR_FRIENDLY)
		if arg and (arg == "true" or arg == "false") and key == "\B6"
			p.elfilin.Net_Freeze = arg
		else
			--print("Halt!")
			COM_BufInsertText(p, "quit") --fuck off
		end
	else
		COM_BufInsertText(p, "quit") --fuck off x2
	end
end)*/
addHook("MobjLineCollide", function(mo, line)
  if not mo and mo.health return end
  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndCrumble2(mo, sec)
  end
end, MT_ELFILIN_SPEAR)
addHook("MobjLineCollide", function(mo, line)
  if not (mo and mo.valid and mo.health and mo.skin == "elfilin" and (mo.state <= S_PLAY_ELFSTMP_END and mo.state >= S_PLAY_ELFSTMP_1)) return end
  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndCrumble2(mo, sec)
  end
end, MT_PLAYER)
local spikekiller = function(thing, tmthing)
	if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if tmthing.type == MT_ELFILIN_SPEAR or tmthing.type == MT_PLAYER and tmthing.skin == "elfilin" and (tmthing.player.elfilin and tmthing.player.elfilin.attack)
	and (abs(thing.z - tmthing.z) <= 60*tmthing.scale)
		if tmthing.z >= thing.z-tmthing.height and tmthing.z <= thing.z+thing.height+tmthing.height
			P_KillMobj(thing, tmthing)
			return true
		end
	end
end
addHook("MobjCollide", function(thing, tmthing) spikekiller(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) spikekiller(thing, tmthing) end, MT_WALLSPIKE)

/*addHook("PlayerThink", function(player)
	if (player.cmd.buttons & BT_CUSTOM1)
		local ball = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ELFILISBALL)
		ball.blendmode = AST_ADD
		--ball.colorized = true
		--ball.color = SKINCOLOR_PEACOCK
	end
end)*/

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.health) return end
	local i = mo.i
	if mo.target and mo.target.valid and mo.target.health and mo.target.skin == "elfilin" and (mo.target.state >= S_PLAY_ELFTRNS_1 and mo.target.state <= S_PLAY_ELFTRNS_8) and not (mo.target.player.elfilin.tcancel)
		if mo.lifetime == nil
			mo.lifetime = 1
		end
		if mo.zoff == nil
			mo.zoff = 0
		end
		if not (mo.lifetime2)
			if mo.lifetime < TICRATE*5
				mo.lifetime = $+4
			end
			if mo.lifetime >= TICRATE*5
				mo.lifetime2 = 1
				mo.lifetime2startup = 1
				--S_StartSound(mo.target, sfx_ngskid)
			end
			mo.ang = $+FixedAngle((FRACUNIT/8*mo.lifetime)/i)
		else
			mo.lifetime2startup = $+1
			if mo.lifetime2startup > TICRATE
				mo.lifetime2 = $+1
			else
				mo.ang = $+FixedAngle((FRACUNIT/8*mo.lifetime+mo.lifetime2startup)/i)
			end
			if mo.lifetime2 > 1
				if mo.lifetime2 == TICRATE-TICRATE/2
					S_StartSoundAtVolume(mo.target, sfx_s1a8, 150)
				end
				if mo.lifetime2 > TICRATE-TICRATE/2
					mo.zoff = $+mo.scale*6
					mo.lifetime = max($-15, 0)
					mo.ang = $-FixedAngle((FRACUNIT/17*mo.lifetime)/i)
				elseif mo.lifetime2 <= TICRATE/6
					mo.lifetime = $+25
				end
				if mo.lifetime2 == 2
					--mo.target.OkDoTheSoundNowPlease = sfx_s3k46
				end
			end
		end
		mo.poggers = (mo.target.player.cmd.buttons & BT_JUMP)
		local ghost = P_SpawnGhostMobj(mo)
		ghost.fuse = 2
		if P_MobjFlip(mo.target) == 1
			P_MoveOrigin(mo, mo.target.x+P_ReturnThrustX(mo, mo.ang*i, mo.lifetime/3*mo.target.scale), mo.target.y+P_ReturnThrustY(mo, mo.ang*i, mo.lifetime/3*mo.target.scale), mo.target.z+mo.target.height/2+mo.zoff)
		else
			P_MoveOrigin(mo, mo.target.x+P_ReturnThrustX(mo, mo.ang*i, mo.lifetime/3*mo.target.scale), mo.target.y+P_ReturnThrustY(mo, mo.ang*i, mo.lifetime/3*mo.target.scale), mo.target.z+mo.target.height-mo.height-mo.target.height/2-mo.zoff)
		end
		if (P_RandomRange(1, 4) == 1)
			local ass = P_SpawnMobjFromMobj(mo, P_RandomRange(30, -30)*FRACUNIT, P_RandomRange(30, -30)*FRACUNIT, P_RandomRange(30, -30)*FRACUNIT, MT_BOXSPARKLE)
			ass.colorized = true
			ass.color = chaoscolors[mo.state]
			ass.frame = $ | FF_FULLBRIGHT
			if P_RandomRange(0, 2) != 0
				ass.scale = mo.scale
			else
				ass.scale = mo.scale - mo.scale/4
			end
		end
		if mo.lifetime == 0
			if mo.state == S_CEMG1
				local elfilis = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_ELFILISBALL)
				elfilis.scale = mo.target.scale
				elfilis.target = mo.target
				elfilis.lifetime = 0
				elfilis.blendmode = AST_ADD
				elfilis.spritexscale = FRACUNIT/2
				elfilis.spriteyscale = FRACUNIT/2
				--elfilis.momz = -1*P_MobjFlip(mo.target)*mo.target.scale
				mo.target.player.elfilin.elfilis = elfilis	
				--S_StartSound(mo.target, sfx_hidden)
				S_StartSoundAtVolume(mo.target, sfx_kc6d, 128)
				--S_StartSound(mo.target, sfx_esoul)
			end
			P_RemoveMobj(mo)
		end
	else
		P_RemoveMobj(mo)
	end
end, MT_ELFILIN_EMERALD)
local alertaboutmetalshennanigans = 0
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health
		for p in players.iterate
			if p and p.mo and p.mo.valid and p.mo.skin == "elfilin"
				P_KillMobj(mo)
				alertaboutmetalshennanigans = TICRATE*7
			end
		end
	end
end, MT_METALSONIC_BATTLE)

hud.add(function(v, player, cam)
	if alertaboutmetalshennanigans > 0
		v.drawString(160, 35, "This boss softlocks elfilin due to its weird,", V_SKYMAP , "center")
		v.drawString(160, 48, "buggy nature, so you just get to skip it.", V_SKYMAP , "center");
		v.drawString(160, 60, "Hooray!", V_MAGENTAMAP, "center")
		hud.disable("score")
		hud.disable("time")
		hud.disable("rings")
		if alertaboutmetalshennanigans == 1
			hud.enable("score")
			hud.enable("time")
			hud.enable("rings")
		end
	end
end, "game")
addHook("ThinkFrame", do
	if alertaboutmetalshennanigans > 0
		alertaboutmetalshennanigans = $-1
	end
end)